package com.zcloud.mapper.dsno3.task;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;

import java.util.List;

/**
 * 说明：阶段考试学员关系表
 * 作者：luoxiaobao
 * 时间：2021-10-08
 * 官网：www.zcloudchina.com
 */
public interface StageStudentRelationMapper{

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	void save(PageData pd);

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	void delete(PageData pd);

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	void edit(PageData pd);

	/**列表
	 * @param page
	 * @throws Exception
	 */
	List<PageData> datalistPage(Page page);

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	List<PageData> listAll(PageData pd);

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	PageData findById(PageData pd);

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	void deleteAll(PageData pd);

	/**列表(根据所选ID获取数据)
	 * @param pd
	 * @throws Exception
	 */
	List<PageData> findByIds(PageData pd);

	/**
	 * 获取所选考试人员
	 * @param pd
	 * @return
	 * @throws Exception
	 */
    List<PageData> findByExamPaper(PageData pd);

	/**
	 * 根据试卷ID删除考试人员
	 * @param pd
	 */
    void deleteByExamPaper(PageData pd);

	/**
	 * 列表【我的考试】（获取当前用户的所属阶段考试信息）
	 * @param page
	 * @return
	 * @throws Exception
	 */
    List<PageData> pageDataByUserlistPage(Page page);

	/**修改（更新学员考试状态）
	 * @param
	 * @throws Exception
	 */
	void updateStudentState(PageData pd);

	/**修改（更新学员考试成绩及状态）
	 * @param
	 * @throws Exception
	 */
	void updateStudentScore(PageData pd);

	/**
	 * 处理没有参加考试的学员阶考，考试未考STAGEEXAMSTATE = '4'
	 * @param pd
	 */
    void overStage(PageData pd);

	/**列表【app我的任务】（获取当前用户的所属任务信息列表）
	 * @param page
	 * @throws Exception
	 */
	List<PageData> pageTaskByUserlistPage(Page page);

	/**
	 *  【app学习详细】（根据STAGESTUDENTRELATION_ID获取当前的修改任务）
	 * @param pd
	 * @return
	 */
	PageData getMyTask(PageData pd);

	/**列表【app成绩查询】（获取当前用户的所属考试信息列表）
	 * @param page
	 * @return
	 * @throws Exception
	 */
	List<PageData> pageTaskScoreByUserlistPage(Page page);
	/**修改  学习完成的 任务 人员关系表
	 * @param pd
	 * @throws Exception
	 */
	void updateClassHourAndCount(PageData pd)throws Exception;
}

